"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateQueryNode = void 0;
const object_utils_js_1 = require("../util/object-utils.js");
/**
 * @internal
 */
exports.UpdateQueryNode = (0, object_utils_js_1.freeze)({
    is(node) {
        return node.kind === 'UpdateQueryNode';
    },
    create(table, withNode) {
        return {
            kind: 'UpdateQueryNode',
            table,
            ...(withNode && { with: withNode }),
        };
    },
    cloneWithUpdates(updateQuery, updates) {
        return (0, object_utils_js_1.freeze)({
            ...updateQuery,
            updates: updateQuery.updates
                ? (0, object_utils_js_1.freeze)([...updateQuery.updates, ...updates])
                : updates,
        });
    },
});
