"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseOrderBy = void 0;
const order_by_item_node_js_1 = require("../operation-node/order-by-item-node.js");
const raw_node_js_1 = require("../operation-node/raw-node.js");
const reference_parser_js_1 = require("./reference-parser.js");
function parseOrderBy(ctx, orderBy, direction) {
    return order_by_item_node_js_1.OrderByItemNode.create(parseOrderByExpression(ctx, orderBy), parseOrderByDirectionExpression(direction));
}
exports.parseOrderBy = parseOrderBy;
function parseOrderByExpression(ctx, expr) {
    return (0, reference_parser_js_1.parseReferenceExpression)(ctx, expr);
}
function parseOrderByDirectionExpression(expr) {
    if (!expr) {
        return undefined;
    }
    if (expr === 'asc' || expr === 'desc') {
        return raw_node_js_1.RawNode.createWithSql(expr);
    }
    else {
        return expr.toOperationNode();
    }
}
